;
;   Module name      :	ExampleCmdLine.au3
;
;   Sw requirements  :	CmdLine.au3 ver. 1.01
;
;   Parameters       :	None
;   Notes - usage    :	None
;


;--- Global directives -----------------------------------------------------------------------------



Opt("TrayIconDebug", 1)

Opt("MustDeclareVars", 1)
Opt("GUICloseOnESC", 0)



;--- Include files ---------------------------------------------------------------------------------



#include "CmdLine.au3"



;--- Global constants ------------------------------------------------------------------------------



const $FILE_NAME = "ExampleCmdLine.au3"

; Switch definitions (the first must be: $SWITCH_ERR = $CL_SWITCH_ERR)
enum $SWITCH_ERR = $CL_SWITCH_ERR, $SWITCH_HELP, $SWITCH_VER, $SWITCH_SWITCH0, $SWITCH_SWITCH1
const $SWITCH_COUNT = 5										; Total number of switch definitions
const $SWITCH[$SWITCH_COUNT][3] = _
	[ _
		[$SWITCH_ERR,		"",			0], _
		[$SWITCH_HELP,		"/?",		0], _
		[$SWITCH_VER,		"/ver",		0], _
		[$SWITCH_SWITCH0,	"switch0",	0], _
		[$SWITCH_SWITCH1,	"switch1",	1] _
	]



;--- Global variables ------------------------------------------------------------------------------



global $Curr_switch, $Curr_switch_ndx, $Curr_params_ndx
global $Mandatory_switch = False
global $Msg



;--- Functions code --------------------------------------------------------------------------------



func ShowMsg($msg, $stop = False)
;---
; Displays a message in a Message Box and optionally stop the script.
;
; $msg	message
; $stop	if True, the execution of the script is stopped
; ret	nothing
;---
	if ($stop) then
		MsgBox(0 + 16, $FILE_NAME, $msg)			; 0 + 16 = $MB_OK + $MB_ICONHAND
		Exit
	else
		MsgBox(0 + 64, $FILE_NAME, $msg)			; 0 + 64 = $MB_OK + $MB_ICONASTERISK
	endif
endfunc



;--- Main code -------------------------------------------------------------------------------------



if ($CmdLine[0] == 0) then
	ShowMsg("Run this script with parameter ""/?"" to see Help", True)
endif

$Msg = "Specified switches:" & @LF
while (CLGetOpts($SWITCH, $Curr_switch, $Curr_switch_ndx, $Curr_params_ndx))
	switch $Curr_switch
		case $SWITCH_ERR
			ShowMsg("parameter '" & $CmdLine[$Curr_switch_ndx] & "' incorrect or incomplete", True)
		case $SWITCH_HELP
			ShowMsg("Usage: " & $FILE_NAME & " [/?] [/ver] switch0 [switch1 <param>]" & @LF & @LF & _
					"Parameters can be repeated and specified in any order." & @LF & _
					"""/?"" and ""/ver"" stop script execution when found.")
			exit
		case $SWITCH_VER
			ShowMsg("CmdLine example, ver. 1.01")
			exit
		case $SWITCH_SWITCH0
			$Mandatory_switch = True
			$Msg &= "- " & $CmdLine[$Curr_switch_ndx] & @LF
		case $SWITCH_SWITCH1
			$Msg &= "- " & $CmdLine[$Curr_switch_ndx] & "; param: " & $CmdLine[$Curr_params_ndx] & @LF
	endswitch
wend

if ($Mandatory_switch) then
	ShowMsg($Msg & @LF & "Result ok: ""switch0"" specified correctly (it was not optional)")
else
	ShowMsg($Msg & @LF & "Error: the mandatory switch ""switch0"" has not been specified", True)
endif
