;
;   Module name      :	TestCmdLine.au3
;
;   Description      :	None
;
;   Parameters       :	None
;   Notes - usage    :	None
;


;--- Global directives -----------------------------------------------------------------------------



Opt("TrayIconDebug", 1)

Opt("MustDeclareVars", 1)
Opt("GUICloseOnESC", 0)



;--- Include files ---------------------------------------------------------------------------------



#include <DebugUtil.au3>
#include "CmdLine.au3"



;--- Global constants ------------------------------------------------------------------------------



;--- Global variables ------------------------------------------------------------------------------



global $Module_prefix = "CL"



;--- Functions code --------------------------------------------------------------------------------



func PrintFooter()
;---
; Prints the ending string.
;
; ret	nothing
;---
	DURawPrint("--- End of tests (" & @HOUR & ":" & @MIN & ":" & @SEC & ") ---" & @CRLF)
endfunc



func PrintHeader()
;---
; Sets the debug Notepad window and prints the title.
;
; ret	nothing
;---
	DUInit("Test file for " & eval($Module_prefix & "_FILE_NAME") & " " & eval ($Module_prefix & "_MODULE_VER"))
	DURawPrint("--- Start of tests (" & @HOUR & ":" & @MIN & ":" & @SEC & ") ---")
endfunc



;--- Main code -------------------------------------------------------------------------------------



PrintHeader()

; Test code for CmdLine.au3 starts here.

if ($CmdLine[0] == 0) then
	DURawPrint("Run this test script with following parameters:")
	DURawPrint("/? switch1 abc /? switch0 /ver")
	PrintFooter()
	exit
endif

global $sw, $sw_ndx, $params_ndx
enum $SWITCH_ERR = $CL_SWITCH_ERR, $SWITCH_HELP, $SWITCH_VER, $SWITCH_SWITCH0, $SWITCH_SWITCH1

DUPrint($CmdLineRaw, $CmdLine)		; For this tests, parameters should be: "/? switch1 abc /? switch0 /ver"

#cs
CLResetOpts()
global $sw_def[5][3] = _
	[ _
		[$SWITCH_ERR,		"",			0], _
		[$SWITCH_HELP,		"/?",		0], _
		[$SWITCH_VER,		"/ver",		0], _
		[$SWITCH_SWITCH0,	"switch0",	0], _
		[$SWITCH_SWITCH1,	"switch1",	1] _
	]
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 1 ($SWITCH_HELP), $sw_ndx = 1
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 4 ($SWITCH_SWITCH1), $sw_ndx = 2
		$params_ndx, $CmdLine[$params_ndx])					; $params_ndx = 3 ("abc")
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 1 ($SWITCH_HELP), $sw_ndx = 4
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 3 ($SWITCH_SWITCH0), $sw_ndx = 5
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 2 ($SWITCH_VER), $sw_ndx = 6
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx))		; Parameters ended, CLGetOpts returns False
#ce

#cs
CLResetOpts()
global $sw_def[5][3] = _
	[ _
		[$SWITCH_ERR,		"",			0], _
		[$SWITCH_HELP,		"/?",		2] _
	]
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 1 ($SWITCH_HELP), $sw_ndx = 1
		$params_ndx, $CmdLine[$params_ndx])					; $params_ndx = 2 ("switch1")
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 1 ($SWITCH_HELP), $sw_ndx = 4
		$params_ndx, $CmdLine[$params_ndx])					; $params_ndx = 5 ("switch0")
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx))		; Parameters ended, CLGetOpts returns False
#ce

#cs
CLResetOpts()
global $sw_def[5][3] = _
	[ _
		[$SWITCH_ERR,		"",			0], _
		[$SWITCH_HELP,		"/?",		3], _
		[$SWITCH_SWITCH0,	"switch0",	0], _
		[$SWITCH_VER,		"/ver",		1] _
	]
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 1 ($SWITCH_HELP), $sw_ndx = 1
		$params_ndx, $CmdLine[$params_ndx])					; $params_ndx = 2 ("switch1")
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 3 ($SWITCH_SWITCH0), $sw_ndx = 5
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 0 ($SWITCH_ERR, "/ver" has 1 req. param.),
		$params_ndx)										; $sw_ndx = 6, $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx))		; Parameters ended, CLGetOpts returns False
#ce

#cs
CLResetOpts()
global $sw_def[5][3] = _
	[ _
		[$SWITCH_ERR,		"",			0], _
		[$SWITCH_SWITCH0,	"switch0",	0], _
		[$SWITCH_SWITCH1,	"switch1",	1] _
	]
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 0 ($SWITCH_ERR, "/?" not defined),
		$params_ndx)										; $sw_ndx = 1, $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 4 ($SWITCH_SWITCH1), $sw_ndx = 2
		$params_ndx, $CmdLine[$params_ndx])					; $params_ndx = 3 ("abc")
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 0 ($SWITCH_ERR, "/?" not defined),
		$params_ndx)										; $sw_ndx = 4, $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 3 ($SWITCH_SWITCH0), $sw_ndx = 5
		$params_ndx)										; $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx), _	; Parameters not ended, CLGetOpts returns True
		$sw, $sw_ndx, $CmdLine[$sw_ndx], _					; $sw = 0 ($SWITCH_ERR "/ver" not defined),
		$params_ndx)										; $sw_ndx = 6, $params_ndx undefined
DUPrint(CLGetOpts($sw_def, $sw, $sw_ndx, $params_ndx))		; Parameters ended, CLGetOpts returns False
#ce

; Test code for CmdLine.au3 ends here.

PrintFooter()
